[![py37](https://github.com/fhswf/MLPro/actions/workflows/python37.yml/badge.svg)](https://github.com/fhswf/MLPro/actions/workflows/python37.yml)
[![py38](https://github.com/fhswf/MLPro/actions/workflows/python38.yml/badge.svg)](https://github.com/fhswf/MLPro/actions/workflows/python38.yml)
[![py39](https://github.com/fhswf/MLPro/actions/workflows/python39.yml/badge.svg)](https://github.com/fhswf/MLPro/actions/workflows/python39.yml)
[![Documentation Status](https://readthedocs.org/projects/mlpro/badge/?version=latest)](https://mlpro.readthedocs.io/en/latest/?badge=latest)

<img src="doc/\logo/original/logo.png" align="right" width="40%"/>

# MLPro - Machine Learning Professional
Machine Learning Professional - A Synoptic Framework for Standardized Machine Learning Tasks in Python

MLPro provides complete, standardized, and reusable functionalities to support your scientific research, educational tasks or industrial projects in machine learning.

Project MLPro was started in 2021 by [Automation Technology and Learning Systems team at Fachhochschule Südwestfalen](https://www.fh-swf.de/de/forschung___transfer_4/labore_3/labs/labor_fuer_automatisierungstechnik__soest_1/standardseite_57.php)


# Key Features

a) Open, modular and extensible architecture
- Overarching software infrastructure (logging, data management, mathematics, UI framework, ...)
- Fundamental ML classes for adaptive models and their training and hyperparameter tuning

b) Sub-Package for Reinforcement Learning
- Powerful Environment templates for simulation, training and real operation
- Templates for single-agents, model-based agents (MBRL) with action planning to multi-agents (MARL)
- Advanced training/tuning funktionalities with separate evaluation and progress detection
- Growing pool of reuseable environments of automation and robotics

c) Sub-Package for Cooperative Game Theory
- Templates for (potential based) game boards
- Templates for cooperative multi-players
- Reuse of advanced training/tuning classes and multi-agent environments of sub-package RL

d) Numerous executable self study examples

e) Integration of established 3rd party packages (Wrapper classes) 
- Environments of OpenAI Gym and PettingZoo
- Policy Algorithms of Stable Baselines 3
- Hyperparameter Tuning with Hyperopt


# Development
- Consequent object-oriented design and programming
- Clean code paradigma
- Test-driven development in GitHub (CI/CD concept)


# Documentation
The Documentation is available on : [https://mlpro.readthedocs.io/](https://mlpro.readthedocs.io/)


# Team MLPro
MLPro is currently designed and developed by [Detlef Arend](https://github.com/detlefarend), [M Rizky Diprasetya](https://github.com/rizkydiprasetya), [Steve Yuwono](https://github.com/steveyuwono), [William Budiatmadjaja](https://github.com/budiatmadjajaWill)


# How to contribute
If you want to contribute, please read [CONTRIBUTING.md](https://github.com/fhswf/MLPro/blob/master/CONTRIBUTING.md)